<?

$strings['LOAD'] = "Oops, the server is currently experiencing greater-than-average load. Please try again later, or be selfish and try again right now.";
$strings['AUTH'] = "Authorization Required.";

$statuses['AWY'] = "Away";
$statuses['NLN'] = "Online";
$statuses['FLN'] = "Offline";
$statuses['PHN'] = "On The Phone";
$statuses['BRB'] = "Be Right Back";
$statuses['HDN'] = "Hidden";
$statuses['BSY'] = "Busy";
$statuses['FLN'] = "Offline";
$statuses['IDL'] = "Idle";
$statuses['LUN'] = "Out to Lunch";

function do_challenge($key){
        return md5($key."Q1P7W2E4J9R8U3S5");
}

function leave_switchboard($sid){
	global $sbs;
	if (is_array($sbs)){
		foreach ($sbs as $key=>$sb){
			if ($sb['sid'] == $sid){
				fputs($sbs[$key]['socket'],"OUT\r\n");
				$sbs[$key]['socket'] = null;
				rebuild_switchboards();
				return;
			}
		}
	}
}


function error($message="Error"){
	echo $message;
	msn_logout(true);
}

function mangle($it){
	return substr($it,5,2).substr($it,3,2).substr($it,1,2);
}

function unmangle($it){
	return substr($it,4,2).substr($it,2,2).substr($it,0,2);
}

function send_message_to_switchboard($sid,$effects,$colour,$font,$msg){
	global $sbs,$username;

	$colour = str_replace("C","#",$colour);

	if (is_array($sbs)){
		foreach ($sbs as $key=>$sb){
			if ($sb['sid'] == $sid){
				break;
			}
		}
	}

	if ($sb['sid'] != $sid){
		echo "<script>try{tabber.send_signal_to_tab('".$sid."','ERRM');}catch(temp){}</script>";
		return;
	}
	$temp = $colour;
	if (trim($colour) == ""){
		$colour = "0";
	} else {
		$colour = mangle($colour);
	}

	if (trim($font == "")){
		$font = "sans-serif";
	}

	$message = "MIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nX-MMS-IM-Format: FN=".$font."; EF=".$effects."; CO=".$colour."; CS=0; PF=22\r\n\r\n";
	$message .= stripslashes(str_replace("\n","\r\n",$msg));
	$header = "MSG ".$sb['trid']." A ".strlen($message)."\r\n";
	$it = $header.$message;
	@fputs($sb['socket'],$it);
	$sb['trid']++;
	$return = @fgets($sb['socket'],128);
	if ((substr($return,0,3)!="ACK") && (strlen(trim($return))!=0)){
		echo "<script>try{tabber.send_signal_to_tab('".$sid."','NACK');}catch(temp){}</script>";
	} else {
		echo "<script>try{tabber.tab_msg('".$sid."','".$username."','".str_replace(array("\r","\n"),"",replace_smileys(nl2br(stripslashes($msg))))."','$font','$temp','$effects');}catch(temp){}</script>";
	}
	$sbs[$key] = $sb;
}

function open_sb_to_user($username){
	global $sbs;
	if (is_array($sbs)){
		foreach ($sbs as $key=>$sb){
			foreach ($sb['participants'] as $temp){
				if ($temp['email'] == $username){
					echo "<script>open_convo_window();</script>";
					return false;
				}
			}
		}
	}
	$sbs[]['socket'] = conjure_sb();
	if ($sbs[count($sbs)-1]['socket'] == FALSE){
		return false;
	}
	$sbs[count($sbs)-1]['trid'] = 2;
	$temp = handle_click($username,end($sbs));
	if ($temp != FALSE){
		$sbs[count($sbs)-1]['sid'] = rtrim($temp);
	} else {
		return false;
	}
	@socket_set_nonblock($sbs[count($sbs)-1]['socket']);
	@socket_set_timeout($sbs[count($sbs)-1]['socket'],0,125000);
	echo "<script>	temp = switchboards.length;
			switchboards[temp] = new Array;
			switchboards[temp]['sid'] = '".rtrim($temp)."';
			switchboards[temp]['participants'] = new Array;
			switchboards[temp]['participants'][0] = new Array;
			switchboards[temp]['participants'][0]['email'] = '".$username."';
			switchboards[temp]['participants'][0]['name'] = '".$username."';
			switchboards[temp]['fresh'] = 1;
			open_convo_window();
			try{tabber.check_em();}catch(temp){}
			</script>";
}

function join_switchboard($stuff){
	global $username,$sbs;
	$temp_array = explode(" ",$stuff);

	list($server,$port) = explode(":",$temp_array[2]);

	$sb_conn = fsockopen($server,$port) or error("The server running this software seems to be having network problems.");

	if (!is_resource($sb_conn)){
		return;
	}

	$auth_string = $temp_array[4];
	$sid = $temp_array[1];

	fputs($sb_conn,"ANS 1 ".$username." $auth_string $sid\r\n");

	$temp = fgets($sb_conn,128);
	if (trim($temp) == ""){
		return;
	}
	while (substr($temp,0,3)!= "ANS"){
		$iros[] = $temp;
		$temp = fgets($sb_conn,128);
	}
	foreach ($iros as $iro){
		$temp_array = explode(" ",$iro);
		$participants[] = array("email"=>$temp_array[4],"name"=>$temp_array[5]);
	}
	$sb['participants'] = $participants;
	$sb['sid'] = $sid;
	$sb['trid'] = 2;
	$sb['socket'] = $sb_conn;
	@socket_set_nonblock($sb['socket']);
	@socket_set_timeout($sb['socket'],0,125000);
	$sbs[] = $sb;
}

function rm_user($username){
	global $conn,$trid,$weird_thing;
	fputs ($conn,"REM $trid FL ".$weird_thing[$username]."\r\n");
	$trid++;
}

function add_user($username){
	global $conn,$trid;
	if (trim($username) != ""){ 
		fputs($conn,"ADC $trid FL N=$username F=foobardude\r\n");
		$trid++;
	}
}

function block_user($username){
	global $conn,$trid;
	fputs ($conn,"REM $trid AL $username\r\n");
	$trid++;
	fputs($conn,"ADC $trid BL N=$username\r\n");
	$trid++;
}

function unblock_user($username){
	global $conn,$trid;
	fputs ($conn,"REM $trid BL $username\r\n");
	$trid++;
	fputs($conn,"ADC $trid AL N=$username\r\n");
	$trid++;
}

function change_my_name($newname){
	global $trid,$conn;
	fputs($conn,"PRP $trid MFN ".rawurlencode($newname)."\r\n");
	$trid++;
}

function rename_user($who,$alias){
	global $conn,$trid;
	if (trim($alias) != ""){
		echo "<script>parent.buddy_list.aliases['$who'] = '$alias';parent.buddy_list.redraw_contactlist();</script>";
	}
}

function conjure_sb(){
	global $conn,$trid,$username;
	fputs($conn,"XFR $trid SB\r\n");
	$trid++;
	for($stuff = "";$stuff == "";$stuff=fgets($conn,128));
	$temp = explode(" ",$stuff);
	$auth = $temp[5];
	$temp = explode(":",$temp[3]);
	$sb_socket = @fsockopen($temp[0],$temp[1]);

	if (!is_resource($sb_socket)){
		return;
	}

	fputs($sb_socket,"USR 1 $username $auth\r\n");

	$stuff=fgets($sb_socket,128);

	if (substr($stuff,0,3) == "USR"){
		if (is_resource($sb_socket)){
			return $sb_socket;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function handle_click($username,$sb){
	global $sbs;
	$socket = $sb['socket'];
	$trid = $sb['trid'];
	fputs($socket,"CAL $trid $username\r\n");
	$stuff=fgets($socket,128);
	if (substr($stuff,0,strlen("CAL $trid RINGING")) == "CAL $trid RINGING"){
		$temp = explode(" ",$stuff);
		return $temp[3];
	} else {
		return false;
	}
}

function remove_participant($sb,$who){
	global $sbs;
	foreach ($sb['participants'] as $key => $value){
		if ($value['email'] != $who){
			$temp_array[] = $value;
		} else {
			echo "<script>try{tabber.remove_participant('".$sb['sid']."','".$who."');} catch(temp){}</script>";
		}
	}
	if (count($temp_array)<1){
		remove_sb($sb['sid']);
	} else {
		if (is_array($sbs)){
			foreach ($sbs as $key => $value){
				if ($value['sid'] == $sb['sid']){
					$sbs[$key]['participants'] = $temp_array;
				}
			}

			foreach ($temp_array as $key => $values){
				$temp = "switchboards[i]['participants'][$key] = new Array;";
				$temp .= "switchboards[i]['participants'][$key]['email'] = '".$values['email']."';";
				$temp .= "switchboards[i]['participants'][$key]['name'] = '".$values['name']."';";
			}

			echo "<script>
			for (i=0;i<switchboards.length;i++){
				if (switchboards[i].sid == '".$sb['sid']."'){
					switchboards[i]['participants'] = null;
					switchboards[i]['participants'] = new Array;
					".$temp."
				}
			}
			</script>";
		} else {
			echo "<script>switchboards = null;switchboards = new Array;</script>";
		}
	}
}

function remove_sb($sid){
	global $sbs;
	foreach ($sbs as $key => $sb){
		if ($sb['sid'] == $sid){
			unset ($sbs[$key]);
		}
	}
	rebuild_switchboards();
	echo "<script>remove_sb('$sid');</script>";
}

function msn_logout($error=false){
	global $buddies,$conn,$logged_in;
	fputs($conn,"BYE\r\n");
	@fclose($conn);
	echo "<script>document.getElementById('buddies_div').innerHTML='';</script>";
	$logged_in=0;
	if ($error == true){
		output_msn_status ("Error");
	} else {
		output_msn_status ("Offline");
	}
}

function handle_sb_stuff($sb,$stuff){
	if (substr($stuff,0,3) == "MSG"){
		$temp = explode(" ",$stuff);
		$len = $temp[3];
		$from = $temp[1];
		$temp = "";
		while(strlen($temp)<$len){
			$temp.=fgets($sb['socket'],2);
		}
		handle_msg($sb,$temp,$from);
	} else {
		handle_sb_cmd($sb,$stuff);
	}
}

function handle_sb_cmd($sb,$stuff){
	global $sbs;
	$temp = explode(" ",$stuff);
	if ($temp[0] == "BYE"){
		if ($temp[2] == "1"){
			remove_sb($sb['sid']);
			echo "<script>try{tabber.send_signal_to_tab('".$sb['sid']."','TIME');}catch(temp){}</script>";
		} else {
			remove_participant($sb,$temp[1]);
		}
	} elseif ($temp[0] == "JOI"){
		$temp2 = reverse_lookup($sbs,$sb);
		$temp3 = count($sbs[$temp2]['participants']);
		$sbs[$temp2]['participants'][$temp3]['name'] = $temp[2];
		$sbs[$temp2]['participants'][$temp3]['email'] = $temp[1];
		foreach ($sbs[$temp2]['participants'] as $key => $values){
			$temp = "switchboards[i]['participants'][$key] = new Array;";
			$temp .= "switchboards[i]['participants'][$key]['email'] = '".addslashes($values['email'])."';";
			$temp .= "switchboards[i]['participants'][$key]['name'] = '".addslashes($values['name'])."';";
		}

	echo "<script>
	for (i=0;i<switchboards.length;i++){
		if (switchboards[i].sid == '".$sb['sid']."'){
			switchboards[i]['participants'] = null;
			switchboards[i]['participants'] = new Array;
			".$temp."
		}
	}
	</script>";
	}
}

function handle_msg($sb,$stuff,$from){
	list($headers,$message) = explode("\r\n\r\n",$stuff,2);

	$temp_array = explode("\r\n",$headers);
	foreach ($temp_array as $element){
		if (substr($element,0,12)=="Content-Type"){
			list($temp,$message_type) = explode(": ",$element);
		} elseif (substr($element,0,15)=="X-MMS-IM-Format"){
			list($temp,$message_format) = explode(": ",$element);
		}
	}
	if ($message_type == "text/x-msmsgscontrol"){
		echo "<script>try {tabber.typing('".$sb['sid']."');} catch (temp){}</script>";
	} elseif ($message_type == "text/x-clientcaps"){
//		echo "got client caps<br>";
	} elseif (substr($message_type,0,10) == "text/plain"){
		if (!strstr($message,"MSNSLP")){
			$font = "sans-serif";
			$effects = "";
			$colour = "";

			$temp_array = explode("; ",$message_format);
			foreach ($temp_array as $temp){
				if (substr($temp,0,2)=="FN"){
					if (strlen(substr($temp,2))>2){
						$font = urldecode(substr($temp,3));
					}
				} elseif (substr($temp,0,2)=="EF"){
					$effects = strtoupper(substr($temp,3));
				} elseif (substr($temp,0,2)=="CO"){
					$colour = unmangle(substr($temp,3));
				}
			}
			echo "<script>
			open_convo_window();
			temp=msn_msg_queue.length;
			msn_msg_queue[temp] = new Array;
			msn_msg_queue[temp]['sid'] = '".$sb['sid']."';
			msn_msg_queue[temp]['from'] = '".addslashes($from)."';
			msn_msg_queue[temp]['font'] = '".addslashes(str_replace("MS ","",$font))."';
			msn_msg_queue[temp]['effects'] = '".$effects."';
			msn_msg_queue[temp]['colour'] = '".$colour."';
			msn_msg_queue[temp]['message'] = '".addslashes(replace_smileys(str_replace(array("\r\n","\r","\n"),"<br>",trim($message))))."';
			msn_msg_queue[temp]['seen'] = false;
			try {
				tabber.check_msgs();
			} catch (temp){}</script>\r\n";
		}
	}
}

function rebuild_switchboards(){
	global $sbs;
	foreach ($sbs as $sb){
		if (is_resource($sb['socket'])){
			$temp[] = $sb;
		} else {
			echo "<script>remove_sb('".$sb['sid']."');</script>";
		}
	}
	$sbs = $temp;
}

function output_msn_status($status){
	global $statuses;
	foreach ($statuses as $key=>$statuss){
		if ($status ==$statuss){
			echo "<script>parent.menu.document.getElementById('current_status_dropdown').value = '$key';</script>";
			break;
		}
	}
}

function set_msn_status($status){
	global $conn,$trid;
	fputs($conn,"CHG $trid $status\r\n");
	$trid++;
}

function msn_login($username,$password,$initial_status="NLN"){
global $trid,$conn,$buddies,$weird_thing,$lists,$hotmail_vars;

$temp = fsockopen("messenger.hotmail.com",1863) or die("failed to connect to msn");
output_msn_status("Logging in..");

fputs($temp,"VER 0 MSNP10 CVR0\r\n");
fgets($temp,256);
fputs($temp,"CVR 1 0x0409 winnt 5.1 i386 MSNMSGR 5.0.0540 MSMSGS $username\r\n");
fgets($temp,512);
fputs($temp,"USR 2 TWN I $username\r\n");
$temp1 = fgets($temp,128);
if (!stristr($temp1,":")){
	if (substr($temp1,0,3)==601){
		echo "MSN is currently unavailable.";
		die(" ");
	} else {
		output_msn_status('Unauthorized');
		echo "<script>parent.menu.output_special_message('Incorrect username/password',0);</script>";
		return 0;
	}
}
@fclose($temp);

$temp_array = explode(" ",$temp1);
$temp_array = explode(":",$temp_array[3]);

$conn = fsockopen($temp_array[0],$temp_array[1]) or die("failed to connect to xfr server");

fputs($conn,"VER 0 MSNP10 CVR0\r\n");
fgets($conn,256);
fputs($conn,"CVR 1 0x0409 winnt 5.1 i386 MSNMSGR 5.0.0540 MSMSGS $username\r\n");
fgets($conn,512);
fputs($conn,"USR 2 TWN I $username\r\n");
$temp = fgets($conn,256);
$temp_array = explode(" ",$temp);
$token_string = rtrim(end($temp_array));

$nexus_socket = @fsockopen("ssl://nexus.passport.com",443) or error($strings['LOAD']);
@fputs($nexus_socket,"GET /rdr/pprdr.asp HTTP/1.0\r\n\r\n");


while ($temp != "\r\n"){
	$temp = @fgets($nexus_socket,1024);
	if (substr($temp,0,12)=="PassportURLs"){
		$urls = substr($temp,14);
	}
}

$temp_array = explode(",",$urls);
$temp = $temp_array[1];
$temp = substr($temp,8);

$temp_array = explode("/",$temp);
@fclose($nexus_socket);

$ssl_conn = @fsockopen("ssl://".$temp_array[0],443) or error($strings['LOAD']);
@fputs($ssl_conn,"GET /{$temp_array[1]} HTTP/1.1\r\n");
@fputs($ssl_conn,"Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in=".urlencode($username).",pwd=$password,{$token_string}\r\n");
@fputs($ssl_conn,"User-Agent: MSMSGS\r\n");
@fputs($ssl_conn,"Host: {$temp_array[0]}\r\n");
@fputs($ssl_conn,"Connection: Keep-Alive\r\n");
@fputs($ssl_conn,"Cache-Control: no-cache\r\n\r\n");
$temp = @fgets($ssl_conn,512);
if (!is_resource($ssl_conn)){
	error($strings['LOAD']);
}
if (rtrim($temp) == "HTTP/1.1 302 Found"){
	while ($temp != "\r\n"){
		$temp = fgets($ssl_conn,256);
		if (substr($temp,0,9)=="Location:"){
			$temp_array = explode(":",$temp);
			$temp_array = explode("/",rtrim(end($temp_array)));
			break;
		}
	}
	@fclose($ssl_conn);
	$ssl_conn = @fsockopen("ssl://".$temp_array[2],443) or error($strings['LOAD']);
	fputs($ssl_conn,"GET /{$temp_array[3]} HTTP/1.1\r\n");
	fputs($ssl_conn,"Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in=".urlencode($username).",pwd=$password,{$token_string}\r\n");
	fputs($ssl_conn,"User-Agent: MSMSGS\r\n");
	fputs($ssl_conn,"Host: {$temp_array[2]}\r\n");
	fputs($ssl_conn,"Connection: Keep-Alive\r\n");
	fputs($ssl_conn,"Cache-Control: no-cache\r\n\r\n");
} elseif (rtrim($temp)=="HTTP/1.1 401 Unauthorized"){
	output_msn_status('Unauthorized');
	echo "<script>parent.menu.output_special_message('Incorrect username/password',0);</script>";
	@fclose($ssl_conn);
	return 0;
} else {
	if (rtrim($temp) != "HTTP/1.1 200 OK"){
		echo "Unknown HTTP status code: $temp<br>";
	}
}

while ($temp != "\r\n"){
	$temp = fgets($ssl_conn,1024);
	if (substr($temp,0,19)=="Authentication-Info"){
		$auth_info = $temp;
		$temp = fgets($ssl_conn,1024);
		if (substr($temp,0,14)!="Content-Length"){
			$auth_info.= fgets($ssl_conn,1024);
		}
		break;
	}
}
@fclose($ssl_conn);
$temp_array = explode("'",$auth_info);
if (count($temp_array) == 1){
	output_msn_status('Unauthorized');
	echo "<script>parent.menu.output_special_message('Incorrect username/password',0);</script>";
	return 0;
}

fputs($conn,"USR 3 TWN S {$temp_array[1]}\r\n");
$trid = 4;

$temp = fgets($conn,128);
if (in_array(substr(fgets($conn,128),0,3),array("911","928"))){
	output_msn_status('Unauthorized');
	echo "<script>parent.menu.output_special_message('Incorrect username/password',0);</script>";
	return 0;
}

while(!strstr($temp,"ABCHMigrated") && is_string(trim($temp))){
	$temp = fgets($conn,256);
}
fputs($conn,"SYN $trid 0 0\r\n");
$trid++;
while(substr($temp,0,3)!="SYN"){
	$temp = fgets($conn,256);
}
$temp_array = explode(" ",$temp);
$four = $temp_array[4];


fgets($conn,512);
fgets($conn,512);
$cmp = 0;
while(1){
	$temp = fgets($conn,512);
	if (substr($temp,0,7)=="PRP MFN"){
		$temp_array = explode(" ",$temp);
		$temp_array[2] = rtrim($temp_array[2]);
		echo "<script>parent.topframe.document.getElementById('username_div').innerHTML = '".str_replace(" ","&nbsp;",addslashes(urldecode($temp_array[2])))."';parent.buddy_list.your_name='".addslashes(urldecode($temp_array[2]))."';</script>";
	} elseif (substr($temp,0,3)=="LST"){
		$temp_array = explode(" ",$temp);
		$their_email = substr($temp_array[1],2);
		$their_name = substr($temp_array[2],2);
		$weird_thing[$their_email] = substr($temp_array[3],2);
		$temp = trim(addslashes(rawurldecode($their_name)));
		if ($temp == ""){
			$temp = $their_email;
		}
		$number = $temp_array[4];
		if (($number & 1) == 1){
			$lists['Fl'][$their_email] = TRUE;
		}
		if (($number & 2) == 2){
			$lists['Al'][$their_email] = TRUE;
		}
		if (($number & 4) == 4){
			$lists['Bl'][$their_email] = TRUE;
		}
		if (($number & 8) == 8){
			$lists['Rl'][$their_email] = TRUE;
		}
		if ($lists['Fl'][$their_email]){
			echo "<script>parent.buddy_list.add_user('$their_email','$their_email','FLN',false);</script>\r\n";
			$buddies[] = $their_email;
		}
		$cmp++;
	}
	if ($cmp >= $four){
		break;
	}
}
fputs($conn,"CHG $trid $initial_status 0\r\n");
$trid++;
echo "<script>current_status = '$initial_status';</script>";
$temp = fgets($conn,128);
$temp_array = explode(" ",$temp);
if (is_array($lists['Bl'])){
	foreach ($lists['Bl'] as $key => $value){
		echo "<script>parent.buddy_list.add_block('".$key."');</script>";
	}
}
if ($temp_array[2] != "FLN"){
	stream_set_timeout($conn,0,10000);
	output_msn_status("Online");
	return 1;
} else {
	error($strings['LOAD']);
	return 0;
}
}
function reverse_lookup($one,$two){
	foreach ($one as $a=>$b){
		if ($b == $two){
			return $a;
		}
	}
}
?>
