<html>
<head>
<meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=UTF-8"> 
<style type="text/css">
.unclicked_normal{
border-style: solid;
border-width: 1px;
border-color: #EEEEEE;
}
.unclicked_over{
border-style: outset;
border-width: 1px;
border-color: white;
}
.clicked{
border-style: inset;
border-width: 1px;
border-color: white;
}
BODY { 
	font-family: Verdana, Arial, Helvetica, sans-serif; 
	font-size: 9px; 
} 
TD { 
	font-family: Verdana, Arial, Helvetica, sans-serif; 
	font-size: 9px;
}
.tab {
	padding-top: 2px;
	height: 16px;
	border-left-style: solid;
	border-right-style: solid;
	border-top-style: solid;
	border-bottom-style: solid;
	border-left-color: black;
	border-right-color: black;
	border-top-color: black;
	border-bottom-color: black;
	border-left-width: 1px;
	border-right-width: 1px;
	border-top-width: 1px;
	border-bottom-width: 1px;
	background-color: #DDDDDD;
	cursor: default;
	width: 97px;
	font: 10 Verdana,sans-serif;
}
.empty_tab {
	padding-top: 2px;
	height: 17px;
	border-left-style: none;
	border-right-style: none;
	border-top-style: none;
	border-bottom-style: solid;
	border-bottom-color: black;
	border-bottom-width: 1px;
	background-color: #FFFFFF;
	cursor: default;
	width: 97px;
	font: 10 Verdana,sans-serif;
}
.tab_text {
	font: 10px Verdana,sans-serif;
}
.tab_bar {
	vertical-align: bottom;
	width:415px;
}
.tab_text_current {
	font: 10px Verdana,sans-serif;
}
.close_button {
	border-style: solid;
	border-width: 1px;
	border-color: black;
	font: 8pt verdana,sans-serif;
	text-align: center;
	cursor: pointer;
	cursor: hand;
}
.current_tab {
	padding-top: 2px;
	height: 16px;
	cursor: default;
	border-left-style: solid;
	border-right-style: solid;
	border-top-style: solid;
	border-bottom-style: solid;
	border-left-color: black;
	border-right-color: black;
	border-top-color: black;
	border-bottom-color: #FBFBFB;
	border-left-width: 1px;
	border-right-width: 1px;
	border-top-width: 1px;
	border-bottom-width: 1px;
	background-color: #FBFBFB;
	width: 97px;
	font: 10px Verdana,sans-serif;
}
.message_box{
	overflow: auto;
	word-wrap: break-word;
	padding-left: 5px;
	padding-top: 5px; 
	padding-right: 5px;
	padding-bottom: 5px; 
	background-color: #FBFBFB;
	border-left-style: solid;
	border-right-style: solid;
	border-top-style: none;
	border-bottom-style: solid;
	border-left-color: black;
	border-right-color: black;
	border-bottom-color: black;
	border-left-width: 1px;
	border-right-width: 1px;
	border-bottom-width: 1px;
	height: 300px;
	width: 391px;
	font: 10px Verdana,sans-serif;
}
</style>
<script>
// for message retreival//
var i,j;
var switchboards = new Array;
var sbs;
var msgs;
var temp;
var signals = new Array;
signals['NACK'] = "One or more messages may have not been received";
signals['TIME'] = "The conversation has become inactive and timed out";
signals['ERRM'] = "There was an error sending this message";
//end message retreival//

// for typebox //
var bold = false;
var italic = false;
var underlined = false;
var temp;
var effects;
var text_colour = "#000000";
var font = "sans-serif";
var smileys_popup;
// end typebox//


// for typebox//
function choose_colour(){
	document.getElementById('id_colour').className="clicked";
	var it=window.open('','it','height=170,width=218');
	var colours = new Array("#000000","#000033","#000066","#000099","#0000CC","#0000FF","#330000","#330033","#330066","#330099","#3300CC",
				"#3300FF","#660000","#660033","#660066","#660099","#6600CC","#6600FF","#990000","#990033","#990066","#990099",
				"#9900CC","#9900FF","#CC0000","#CC0033","#CC0066","#CC0099","#CC00CC","#CC00FF","#FF0000","#FF0033","#FF0066",
				"#FF0099","#FF00CC","#FF00FF","#003300","#003333","#003366","#003399","#0033CC","#0033FF","#333300","#333333",
				"#333366","#333399","#3333CC","#3333FF","#663300","#663333","#663366","#663399","#6633CC","#6633FF","#993300",
				"#993333","#993366","#993399","#9933CC","#9933FF","#CC3300","#CC3333","#CC3366","#CC3399","#CC33CC","#CC33FF",
				"#FF3300","#FF3333","#FF3366","#FF3399","#FF33CC","#FF33FF","#006600","#006633","#006666","#006699","#0066CC",
				"#0066FF","#336600","#336633","#336666","#336699","#3366CC","#3366FF","#666600","#666633","#666666","#666699",
				"#6666CC","#6666FF","#996600","#996633","#996666","#996699","#9966CC","#9966FF","#CC6600","#CC6633","#CC6666",
				"#CC6699","#CC66CC","#CC66FF","#FF6600","#FF6633","#FF6666","#FF6699","#FF66CC","#FF66FF","#009900","#009933",
				"#009966","#009999","#0099CC","#0099FF","#339900","#339933","#339966","#339999","#3399CC","#3399FF","#669900",
				"#669933","#669966","#669999","#6699CC","#6699FF","#999900","#999933","#999966","#999999","#9999CC","#9999FF",
				"#CC9900","#CC9933","#CC9966","#CC9999","#CC99CC","#CC99FF","#FF9900","#FF9933","#FF9966","#FF9999","#FF99CC",
				"#FF99FF","#00CC00","#00CC33","#00CC66","#00CC99","#00CCCC","#00CCFF","#33CC00","#33CC33","#33CC66","#33CC99",
				"#33CCCC","#33CCFF","#66CC00","#66CC33","#66CC66","#66CC99","#66CCCC","#66CCFF","#99CC00","#99CC33","#99CC66",
				"#99CC99","#99CCCC","#99CCFF","#CCCC00","#CCCC33","#CCCC66","#CCCC99","#CCCCCC","#CCCCFF","#FFCC00","#FFCC33",
				"#FFCC66","#FFCC99","#FFCCCC","#FFCCFF","#00FF00","#00FF33","#00FF66","#00FF99","#00FFCC","#00FFFF","#33FF00",
				"#33FF33","#33FF66","#33FF99","#33FFCC","#33FFFF","#66FF00","#66FF33","#66FF66","#66FF99","#66FFCC","#66FFFF",
				"#99FF00","#99FF33","#99FF66","#99FF99","#99FFCC","#99FFFF","#CCFF00","#CCFF33","#CCFF66","#CCFF99","#CCFFCC",
				"#CCFFFF","#FFFF00","#FFFF33","#FFFF66","#FFFF99","#FFFFCC","#FFFFFF");

	temp = "<html><head><title>Select Colour</title></head><body marginwidth=0 marginheight=0 leftmargin=0 topmargin=0><center>";
	temp += "<table border=0 cellspacing=1 cellpadding=0 style='width:216px'>";
	for (var i=0; i<216; i++) {
		if ((i % 18) == 0) { temp += "<tr>"; }
		temp += "<td style='width: 10px; height: 12px;background:"+colours[i]+";' onClick=\"javascript:opener.set_colour('"+colours[i]+"');self.close();\" onMouseOver=\"document.getElementById('preview').style.background='"+colours[i]+"';\"></td>";
		if ( ((i+1)>=216) || (((i+1) % 18) == 0)) { 
			temp += "</tr>";
		}
	}
	temp += "<tr><td colspan=18 id=preview style='width:218px;height: 12px;'></td></tr>";
	temp += "</table>";
	it.document.write(temp);
	it.document.close();
}

function stripslashes(temp){
	while (temp.indexOf("\\'")>-1) {
		var pos = temp.indexOf("\\'");
		temp = "" + (temp.substring(0, pos) + "'" + temp.substring((pos + 2), temp.length));
	}
	while (temp.indexOf('\\"')>-1) {
		var pos = temp.indexOf('\\"');
		temp = "" + (temp.substring(0, pos) + '"' + temp.substring((pos + 2), temp.length));
	}
	return temp;
}

function choose_smileys(){
	var smileys_popup = window.open('','smileys_popup','height=190,width=240');
	smileys_popup.document.write("<html><head><title>Smileys</title></head><style>.smiley{padding:4px;}.smileytop{padding:4px;border-top-style:solid;border-top-width:1px;border-top-color:#dedede;}.smileyleft{padding:4px;border-left-style:solid;border-left-width:1px;border-left-color:#a3b5de;}.smileylefttop{padding:4px;border-left-style:solid;border-left-width:1px;border-left-color:#a3b5de;padding:4px;border-top-style:solid;border-top-width:1px;border-top-color:#dedede;}</style>");
	smileys_popup.document.write("<scr");
	smileys_popup.document.write("ipt>function smile(what){opener.document.getElementById('thetext').value+=what;opener.document.getElementById('thetext').focus();self.close();}<");
	smileys_popup.document.write("/script>");
	smileys_popup.document.write("<body>");
	smileys_popup.document.write("<table border=0 style='border-style:solid;border-width:1px;border-color:#848484;'>");
	smileys_popup.document.write("<tr>");
	smileys_popup.document.write("<td class=smiley onClick=\"smile(':)');\"><img src='images/smileys/1.jpg' border=0 /></td><td class=smileyleft onClick=\"smile(':>');\"><img src='images/smileys/2.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileyleft onClick=\"smile(';)');\"><img src='images/smileys/3.gif' border=0 /></td><td class=smileyleft onClick=\"smile(':o');\"><img src='images/smileys/4.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileyleft onClick=\"smile(':p');\"><img src='images/smileys/5.jpg' border=0 /></td><td class=smileyleft onClick=\"smile('(h)');\"><img src='images/smileys/6.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileyleft onClick=\"smile(':@');\"><img src='images/smileys/7.jpg' border=0 /></td>");
	smileys_popup.document.write("</tr><tr>");
	smileys_popup.document.write("<td class=smileytop onClick=\"smile(':s');\"><img src='images/smileys/9.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile(':$');\"><img src='images/smileys/8.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile(':(');\"><img src='images/smileys/10.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile(':\\'(');\"><img src='images/smileys/11.gif' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile(':|');\"><img src='images/smileys/12.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(a)');\"><img src='images/smileys/14.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('({)');\"><img src='images/smileys/35.jpg' border=0 /></td>");
	smileys_popup.document.write("</tr><tr>");
	smileys_popup.document.write("<td class=smileytop onClick=\"smile('(l)');\"><img src='images/smileys/15.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(u)');\"><img src='images/smileys/16.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(m)');\"><img src='images/smileys/17.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(@)');\"><img src='images/smileys/18.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(&)');\"><img src='images/smileys/19.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(s)');\"><img src='images/smileys/20.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(*)');\"><img src='images/smileys/21.jpg' border=0 /></td>");
	smileys_popup.document.write("</tr><tr>");
	smileys_popup.document.write("<td class=smileytop onClick=\"smile('(~)');\"><img src='images/smileys/22.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(8)');\"><img src='images/smileys/23.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(e)');\"><img src='images/smileys/24.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(f)');\"><img src='images/smileys/25.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(w)');\"><img src='images/smileys/26.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(o)');\"><img src='images/smileys/27.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(k)');\"><img src='images/smileys/28.jpg' border=0 /></td>");
	smileys_popup.document.write("</tr><tr>");
	smileys_popup.document.write("<td class=smileytop onClick=\"smile('(g)');\"><img src='images/smileys/29.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(^)');\"><img src='images/smileys/30.gif' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(p)');\"><img src='images/smileys/31.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(i)');\"><img src='images/smileys/32.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(c)');\"><img src='images/smileys/33.jpg' border=0 /></td><td class=smileylefttop onClick=\"smile('(t)');\"><img src='images/smileys/34.jpg' border=0 /></td>");
	smileys_popup.document.write("<td class=smileylefttop onClick=\"smile('(x)');\"><img src='images/smileys/40.jpg' border=0 /></td></tr></table></body></html>");
	smileys_popup.document.close();
}

function over(what){
	if (what == 'bold'){
		if (bold == true){
			document.getElementById('id_bold').className="clicked";
		} else {
			document.getElementById('id_bold').className="unclicked_over";
		}
	} else if (what == 'italic'){
		if (italic == true){
			document.getElementById('id_italic').className="clicked";
		} else {
			document.getElementById('id_italic').className="unclicked_over";
		}
	} else if (what == 'underlined'){
		if (underlined == true){
			document.getElementById('id_underlined').className="clicked";
		} else {
			document.getElementById('id_underlined').className="unclicked_over";
		}
	} else if (what == 'colour'){
		document.getElementById('id_colour').className="unclicked_over";
	} else if (what == 'smileys'){
		document.getElementById('id_smileys').className="unclicked_over";
	}
}

function out(what){
	if (what == 'bold'){
		if (bold == true){
			document.getElementById('id_bold').className="clicked";
		} else {
			document.getElementById('id_bold').className="unclicked_normal";
		}
	} else if (what == 'italic'){
		if (italic == true){
			document.getElementById('id_italic').className="clicked";
		} else {
			document.getElementById('id_italic').className="unclicked_normal";
		}
	} else if (what == 'underlined'){
		if (underlined == true){
			document.getElementById('id_underlined').className="clicked";
		} else {
			document.getElementById('id_underlined').className="unclicked_normal";
		}
	} else if (what == 'colour'){
		document.getElementById('id_colour').className="unclicked_normal";
	} else if (what == 'smileys'){
		document.getElementById('id_smileys').className="unclicked_normal";
	}
}

function toggle_bold(){
	if (bold == true){
		bold = false;
		document.getElementById('id_bold').className = "unclicked_over";
	} else {
		bold = true;
		document.getElementById('id_bold').className = "clicked";
	}
	reval();
}

function toggle_italic(){
	if (italic == true){
		italic = false;
		document.getElementById('id_italic').className = "unclicked_over";
	} else {
		italic = true;
		document.getElementById('id_italic').className = "clicked";
	}
	reval();
}

function toggle_underlined(){
	if (underlined == true){
		underlined = false;
		document.getElementById('id_underlined').className = "unclicked_over";
	} else {
		underlined = true;
		document.getElementById('id_underlined').className = "clicked";
	}
	reval();
}

function set_font(what){
	font = what;
	reval();
}


function set_colour(what){
	text_colour = what;
	reval();
}

function reval(){
	var box = document.getElementById('thetext').style;
	if (bold == true){
		box.fontWeight = 'bold';
		effects = "B";
	} else {
		box.fontWeight = 'normal';
		effects = "";
	}
	if (italic == true){
		box.fontStyle = 'italic';
		effects += "I";
	} else {
		box.fontStyle = 'normal';
	}
	if (underlined == true){
		box.textDecoration = "underline";
		effects += "U";
	} else {
		box.textDecoration = "";
	}
	box.color = text_colour;
	box.fontFamily = font;
}

// end typebox//
function check_em(){
	check_sbs();
	check_msgs();
}

function get_participants_list(sid){
	var temp = opener.parent.buddy_list.switchboards;
	var i = temp.length;

	for (j=0;j<i;j++){
		if (temp[j]['sid'] == sid){
			return temp[j]['participants'];
		}
	}
}

function send_signal_to_tab(sid,signal){
	var i = tabs.length;

	for (j=0;j<i;j++){
		if (tabs[j]['sid'] == sid){
			tabs[j]['contents'] = tabs[j]['contents'] + "<b>"+signals[signal] + "</b><br>";
			show_tabs();
			return;
		}
	}
}

function check_sbs(){
	var sbs = opener.parent.buddy_list.switchboards;
	var temp = sbs.length;
	if (temp > 0){
		for (var x=0;x<temp;x++){
			if (sbs[x]['fresh'] == 1){
				if (tabs.length > 0){
					for (j=0;j<tabs.length;j++){
						if (tabs[j]['sid'] == sbs[x]['sid']){
							break;
						} else {	
							new_blank_tab(sbs[x]['sid'],sbs[x]['participants'][0]['email']);
						}
					}
				} else {
					new_blank_tab(sbs[x]['sid'],sbs[x]['participants'][0]['email']);
				}
				sbs[x]['fresh'] = 0;
			}
		}
	}
}

function check_msgs(){
	var msgs = opener.parent.buddy_list.msn_msg_queue;
	var i = msgs.length;
	if (i > 0){
		for (j=0;j<i;j++){
			if (msgs[j]['seen'] == false){
				tab_msg(msgs[j]['sid'],msgs[j]['from'],msgs[j]['message'],msgs[j]['font'],msgs[j]['colour'],msgs[j]['effects']);
				msgs[j]['seen'] = true;
			}
		}
	}
}

var tabs = new Array;
var temp;
var temp2;
var temp3;
var temp4;
var sid;
var tab_contents = new Array;
var current_tab = 0;
var offset = 0;
var i,j;
var last;
var typinguser = "#00A31B";
var blacktab = "#000000";
var newmsg = "#D01C00";
var statuses = new Array;

function remove_participant(sid,who){
	for (i=0;i<tabs.length;i++){
		if (tabs[i]['sid'] == sid){
			tabs[i]['contents'] += "<b>"+who+" has left the conversation</b><br>";
			show_tabs();
			break;
		}
	}
}

function tab_msg(sid,sender,message_text,message_font,message_colour,message_effects){
	temp = 0;
	for (i=0;i<tabs.length;i++){
		if (tabs[i].sid == sid){
			message_text = stripslashes(message_text);
			tabs[i].contents += "<b>"+sender+" says:</b><br>";
			tabs[i].contents += "<font style='font-family:";
			if (message_font != null){
				tabs[i].contents += message_font;
			} else {
				tabs[i].contents += "sans-serif";
			}
			tabs[i].contents += ";font-size:12px;color:";
			if (message_colour != null){
				tabs[i].contents += message_colour;
			} else {
				tabs[i].contents += "#000000";
			}
			tabs[i].contents += ";'>";
			if (message_effects.indexOf('I')>-1){
				tabs[i].contents += "<I>";
			}
			if (message_effects.indexOf('U')>-1){
				tabs[i].contents += "<U>";
			}
			if (message_effects.indexOf('B')>-1){
				tabs[i].contents += "<B>";
			}
			tabs[i]['contents'] += message_text;
			if (message_effects.indexOf('B')>-1){
				tabs[i].contents += "</B>";
			}
			if (message_effects.indexOf('U')>-1){
				tabs[i].contents += "</U>";
			}
			if (message_effects.indexOf('I')>-1){
				tabs[i].contents += "</I>";
			}
			tabs[i].contents += "</font><br />";
			if (current_tab != i){
				tabs[i].colour = newmsg;
			}
			temp = 1;
			break;
		}
	}
	if (temp == 0){
		temp = tabs.length;
		if (temp>0){
			temp2 = newmsg;
		} else {
			temp2 = blacktab;
		}
		tabs[temp] = new Array;
		tabs[temp]['sid'] = sid;
		tabs[temp]['sender'] = sender;
		tabs[temp]['colour'] = temp2;
		tabs[temp]['contents'] = "<b>"+sender+" says:</b><br>"+stripslashes(message_text)+"<br>";
	}
	untyping(sid);
}

function new_blank_tab(sid,sender){
	temp = tabs.length;
	tabs[temp] = new Array;
	tabs[temp]['sid'] = sid;
	tabs[temp]['sender'] = sender;
	tabs[temp]['colour'] = blacktab;
	tabs[temp]['contents'] = "";
	show_tabs();
}

window.onunload = function() {
close_all_tabs();
}

function close_all_tabs(){
	temp = tabs.length;
	if (temp > 0){
		for(i=0;i<temp;i++){
			close_tab(i);
		}
	}
}

function close_tab(tab_id){
	temp = new Array;
	j=0;
	try{
	opener.parent.buddy_list.leave_switchboard(tabs[tab_id]['sid']);
	} catch (temp){
	}
	if (tabs.length == 1){
		self.close();
		return;
	}
	if (tab_id == current_tab){
		if (current_tab > 0){
			current_tab--;
		}
	} else if ((current_tab > 0) && (current_tab>tab_id)){
		current_tab--;
	}
	for(i=0;i<tabs.length;i++){
		if (i != tab_id){
			temp[j] = new Array;
			temp[j]['sid'] = tabs[i]['sid'];
			temp[j]['sender'] = tabs[i]['sender'];
			temp[j]['colour'] = tabs[i]['colour'];
			temp[j]['contents'] = tabs[i]['contents'];
			j++;
		}
	}
	tabs = temp;
	show_tabs(null);
}

function show_tabs(tab_id){
	temp = "<table width=403 border=0 cellpadding=0 cellspacing=0><tr valign=middle><td style='width:3px;border-bottom-style:solid;border-bottom-width:1px;border-bottom-color:black;'>&nbsp;</td>";
	document.getElementById('messages').innerHTML = "";
	if (tab_id != null){
		current_tab = tab_id;
		tabs[tab_id]['colour'] = blacktab;
	}
	if (tabs.length > 0){
		for (i=0;i<tabs.length;i++){
			temp2 = "";
			temp3 = "";
			temp4 = "tab";
			if ((i == current_tab) || (current_tab == null)){
				if (tabs[i].contents != null){
					tabs[i]['colour'] = blacktab;
					document.getElementById('messages').innerHTML = tabs[i]['contents'];
					document.getElementById('messages').scrollTop=9999;
				}
				temp3 = "_current";
				temp4 = "current_tab";
			}
			if (tabs[i]['istyping'] != null){
				temp2 = typinguser;
			} else {
				temp2 = tabs[i]['colour'];
			}
			temp+="<td onClick='javascript:show_tabs("+i+");' class="+temp4+" align=right><table border=0 cellpadding=0 cellspacing=0 width=100%><tr><td style='width:2px;'>&nbsp;</td><td align=center width=100%><font class=tab_text"+temp3+" color="+temp2+">"+tabs[i].sender.substring(0,13)+"</font></td><td align=right width=*><table class=close_button cellspacing=0 cellpadding=0 onClick='javascript:close_tab("+i+");'><tr><td>&nbsp;X&nbsp;</td></tr></table></td><td style='width:2px;'>&nbsp;</td></tr></table></td><td style='width:4px;border-bottom-style:solid;border-bottom-width:1px;border-bottom-color:black;'>&nbsp;</td>";
		}
	}

		for (i=0;i<(4-tabs.length);i++){
			temp+="<td style='width:100px;border-bottom-style:solid;border-bottom-width:1px;border-bottom-color:black;height:17px;'>&nbsp;</td><td style='width:4px;border-bottom-style:solid;border-bottom-width:1px;border-bottom-color:black;'>&nbsp;</td>";
		}
	
	document.getElementById('tab_bar').innerHTML = temp;
}

function typing(sid){
	for(i=0;i<tabs.length;i++){
		if (tabs[i]['sid'] == sid){
			tabs[i]['istyping'] = true;
			setTimeout("untyping('"+sid+"')",10000);
		}
	}
	show_tabs(null);
}

function untyping(sid){
	for(i=0;i<tabs.length;i++){
		if (tabs[i]['sid'] == sid){
			tabs[i]['istyping'] = null;
		}
	}
	show_tabs(null);
}

function check_submit(evt){
	reval();
	var keyCode;
	try {
		keyCode = window.event.keyCode;
	} catch (temp){
		try {
			keyCode = evt.which;
		} catch (temp){}
	}
	if (keyCode == 13) {
		temp = "boo";
		for (i=0;i<tabs.length;i++){
			if ((i == current_tab) || (current_tab == null)){
				temp = tabs[i]['sid'];
				break;
			}
		}
		if (temp == "boo"){
			alert('Program Error: SID Retrieval Failure!');
		} else {
			if (document.getElementById('thetext').value.length > 0){
				opener.parent.buddy_list.send_data("MSG"+temp+"|"+effects+"|"+text_colour.replace("#","C")+"|"+font+"|"+document.getElementById('thetext').value);
			}
		}
		document.getElementById('thetext').value = "";
		return false;
	}
	return true;
}
</script>
<title>messages - msn</title>
</head>
<body topmargin=0 leftmargin=0 onLoad="javascript:show_tabs(null);check_em();" onKeyDown="check_submit()" onClose="close_all_tabs();">
<table width=403 cellpadding=0 cellspacing=0>
	<tr>
		<td>
			<div id=tab_bar class=tab_bar>
				<table width=403 cellpading=0 cellspacing=0>
					<tr>
						<td style='width:100%;border-bottom-style:solid;border-bottom-width:1px;border-bottom-color:black;border-width:1px;border-style:solid;border-color:black;'>
						</td>
					</tr>
				</table>
			</div>
		</td>
	</tr>
	<tr>
		<td>
			<div id=messages class=message_box>
			</div>
		</td>
	</tr>
</table>
<table><tr>
<td><div class="unclicked_normal" onMouseOver="over('bold');" onMouseOut="out('bold');" id="id_bold" onClick="javascript:toggle_bold();"><img src=images/bold.gif></div></td>
<td><div class="unclicked_normal" onMouseOver="over('italic');" onMouseOut="out('italic');" id="id_italic" onClick="javascript:toggle_italic();"><img src=images/italic.gif></div></td>
<td><div class="unclicked_normal" onMouseOver="over('underlined');" onMouseOut="out('underlined');" id="id_underlined" onClick="javascript:toggle_underlined();"><img src=images/underline.gif></div></td>
<td><div class="unclicked_normal" onMouseOver="over('colour');" onMouseOut="out('colour');" id="id_colour" onClick="javascript:choose_colour();"><img src=images/colour.gif></div></td>
<td><div class="unclicked_normal" onMouseOver="over('smileys');" onMouseOut="out('smileys');" id="id_smileys" onClick="javascript:choose_smileys();"><img src=images/smileys/1.jpg></div></td>
<td><select id=font onChange="set_font(this.value);"><option value='sans-serif' selected>Sans</option><option value=Serif>Serif</option><option value=Courier>Courier</option></select></td>
<td width=100%>&nbsp;</td>
</tr><tr>
<td colspan=7><textarea style="background:#FBFBFB;font-size:12px;font-family:sans-serif;width:402px;height:50px;border-style:solid;border-width:2px;border-color:black;" id=thetext onKeyPress="return check_submit(event);"></textarea></td></tr></table><br>
<script>reval();</script>
</body>
</html>
